#ifndef TEXTURE_UTILS_H
#define TEXTURE_UTILS_H

#include "../include/data_types.h"
#include "../include/global.h"
#include "../include/utilities.h"
#include "../include/file_operations.h"

/**
*   This files handles things like:
*     - Find all the textures used by a PAC file
      - Find All the PAC files that uses a texture
      - Find the original texture names for the files in "files_to_patch" that don't have their original name
*/


#define MAX_TEXTURES 512

int findOriginalTextureName(char* unknownTextureName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo);
FileBlock** getTexturesFrom(FileBlock* fileBlock, char* fileLocation, int* return_texture_count, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo);
void getFilesFromTexture(char* textureName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo);
int isAccordingToFilters(FileBlock* fileBlock);
#endif // TEXTURE_UTILS_H
