#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <windows.h>
#include <conio.h>
#include "../include/utilities.h"
#include "../include/patcher.h"


void checkFiles();
int menu0(long filesPatchedCount);
int menu1();

void menuRemoveOrRestore(int mode);

int main()
{
    int menu0ChosenOption = -1;
    int menu1ChosenOption = -1;

    isWindows10 = (getWindowsVersion() == 10);
    checkFiles();

    while (1)
    {
        long filesPatchedCount = countPatchedFiles();

        menu0ChosenOption = menu0(filesPatchedCount);

        if (menu0ChosenOption == 0)
        {
            break;
        }
        else if (menu0ChosenOption == INSTALL)
        {
            menu1ChosenOption = menu1();
            if (menu1ChosenOption != BACK)
            {
                runPatcher(menu1ChosenOption);
            }
        }
        else if (menu0ChosenOption == 2)
        {
            undoLastChanges();
        }
        else if (menu0ChosenOption == 3)
        {
           backupMenu();
        }
        else if (menu0ChosenOption == 4)
        {
           listPatchedFiles(filesPatchedCount);
        }
        else if (menu0ChosenOption == 5)
        {
           preventFileRecheck();
           PAUSE();
        }
    }
    return 0;
}
int menu0(long filesPatchedCount)
{
    char input = '\0';
    int nOptions = 5;
    int optionSelected = -1;



     // Display the menu to select the region
    while(1) // This condition makes the menu repeat itself until a valid input is entered
    {
        system("cls"); // clears the screen
        printMainHeader();
        printf("Meta file status: ");
        if (filesPatchedCount == 0)
        {
            printColor("Clean", GREEN);
        }
        else
        {
            printf("%ld files currently patched", filesPatchedCount);
        }
        printf("\n\nWhat do you want to do?\n");
        printf("1 - Run Injector\n");
        printf("2 - Undo last changes\n");
        printf("3 - Restore Backup\n");
        printf("4 - List patched files\n");
        printf("5 - Prevent File Re-check\n");
        printf("0 - Exit\n");

        printf("\n\nEnter your choice: ");
        fflush(stdin);
        scanf("%c",&input);
        fflush(stdin);

        if (input == 10) // ENTER
        {
            return 1;
        }

        // Converts the read string to int
        optionSelected = input - '0';

        // This variable also tells the program later which one of the "moddedBytes" the program should use when replacing the bytes

        if (optionSelected == 0)
        {
            return 0;
        }


         // If the user entered an invalid option, displays a error message
        if(optionSelected < 1 || optionSelected > nOptions)
        {
             printf("\nInvalid option! %c(%d)\n\n", input, input);
            Sleep(500);
        }
        else
        {
            break;
        }
    }
    return optionSelected;
}

int menu1()
{
    MenuElements menu;
    menu.nOptions = 2;
    strcpy(menu.header,"How do you want to copy the files from the \"files_to_patch\" folder to their original locations?");
    strcpy(menu.menuoptions[0],"Keep files and folders structures from the \"files_to_patch\" folder.");
    strcpy(menu.menuoptions[1],"Let the program decide where they should go. (Recommended)");

    char* subtittles[] = {"Warning: If any of your files are not in the game's original folder structure they will fail to patch.","Notice: This option will not work if 2 or more files have the same name (like stringtables).\n        Use the other option if that's your case."};

    return createArrowMenu(menu,subtittles,1);
}


void checkFiles()
{
    if (!fileExists("pad00000.meta"))
    {
        printf("\nError: could not locate pad00000.meta\n");
        printf("\nMake sure you place this program in the same folder as the pad00000.meta file.\n");
        printf("\nIf it already is. Try running this program as administrator.\n");
        printf("\nIf that doesn't work either. Move your entire game's folder to your desktop and try again.");
        PAUSE();
    }
}

