#include "../include/partcutdesc_generator.h"


void generatePartcutdesc(FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    int j = 0;
    printf("\nGenerating partcutdesc.xml file...");

    int filesToPatchCount = 0;
    for (j = 0; j < metaFileInfo->fileBlocksCount; j++)
    {
        if (fileBlocks[j].needPatch != 0)
        {
            filesToPatchCount++;
            break;
        }
    }

    if (filesToPatchCount == 0)
    {
        return;
    }

    createPath(concatenate(bdoRootFolder(),"character\\"));
    FILE* partcutdesc = openFile(concatenate(bdoRootFolder(),"character\\partcutdesc.xml"), "wb");

    int classAllowed[TOTAL_CLASSES];
    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }

    createCutTypeBlock("Underwear","38_Underwear",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Event","Event_costume",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    classAllowed[PEW] = 0;
    classAllowed[PWM] = 0;
    classAllowed[PWW] = 0;
    classAllowed[PHW] = 0;
    classAllowed[PBW] = 0;
    createCutTypeBlock("Upperbody","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PEW] = 1;
    classAllowed[PWM] = 1;
    classAllowed[PWW] = 1;
    createCutTypeBlock("PEW_Upperbody","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHW] = 1;
    createCutTypeBlock("PHW_Upperbody02","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    createCutTypeBlock("PBW_Upperbody05","9_Upperbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);


    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }
    classAllowed[PBW] = 0;
    classAllowed[PWM] = 0;
    classAllowed[PWW] = 0;
    createCutTypeBlock("Hand","11_Hand",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    classAllowed[PWM] = 1;
    classAllowed[PWW] = 1;
    createCutTypeBlock("PBW_Hand05","11_Hand",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }
    createCutTypeBlock("Lowerbody","10_Lowerbody",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Foot","12_Foot",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Hel","13_Hel",classAllowed,partcutdesc,metaFileInfo,fileBlocks);
    createCutTypeBlock("Hair","Hair",classAllowed,partcutdesc,metaFileInfo,fileBlocks);


    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHM] = 1;
    classAllowed[PNM] = 1;
    createCutTypeBlock("Sho","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 1;
    }
    createCutTypeBlock("EnchantArm","28_EnchantArm",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PHW] = 1;
    createCutTypeBlock("PHW_Sho02","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    for (j = 0; j < TOTAL_CLASSES; j++)
    {
        classAllowed[j] = 0;
    }
    classAllowed[PBW] = 1;
    classAllowed[PEW] = 1;
    classAllowed[PVW] = 1;
    classAllowed[PWW] = 1;
    classAllowed[PDW] = 1;
    classAllowed[PKWW] = 1;
    classAllowed[PNW] = 1;
    createCutTypeBlock("PBW_Sho","14_Sho",classAllowed,partcutdesc,metaFileInfo,fileBlocks);

    printf("\nDone.\n");

    printf("\nExtracting original partcutdesc file:\n");

    char* command = (char*) malloc (strlen("cd patcher_resources & quickbms.exe -Y -f \"*partcutdesc.xml*\" blackdesert.bms ../PAD00001.PAZ ./") + 1);
    sprintf(command,"cd patcher_resources & quickbms.exe -Y -f \"*partcutdesc.xml*\" blackdesert.bms ../PAD00001.PAZ ./");
    system(command);
    free(command);

    printf("\n\nModifying original partcutdesc.xml...\n");

    char* pathToOriginalPartcutdesc = "patcher_resources\\character\\partcutdesc.xml";

    modifyPartcutdesc(pathToOriginalPartcutdesc,fileBlocks,metaFileInfo);

    printf("\nMerging original and created partcutdesc.xml files...");

    FILE* originalPartCutDescFile = fopen(pathToOriginalPartcutdesc,"rb");

    char c = '\0';

    while(fread(&c,1,1,originalPartCutDescFile))
    {
        fwrite(&c,1,1,partcutdesc);
    }

    fclose(originalPartCutDescFile);
    printf("\nDone.");


    float fileSize = (float)getFileSizeByName(concatenate(bdoRootFolder(),"character\\partcutdesc.xml"));
    fileSize /= 1000.0;

    if (fileSize < 100.0)
    {
        printf("\nSomething went wrong, your partcutdesc.xml file should have at least 100kb and it has %.2f", fileSize);
    }
    else
    {
        printf("\nCompleted!\n\npartcutdesc.xml file size: %.2fkb", fileSize);
    }
    //free(originalPartCutDescMem->bytes);
    fclose(partcutdesc);
}

void modifyPartcutdesc(char* pathToPartcutdesc, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    printf("\n\nModifying \"%s\"...\n",pathToPartcutdesc);
    FILE* originalPartCutDescFile = openFile(pathToPartcutdesc,"rb+");
    PartCutDescEntry* partCutDescEntries = NULL;
    FileBlock* partcutdescFileBlock = NULL;
    char c = '\0';
    char prev_c = '\0';

    // Counts how many file names entries we have
    int entriesCount = 0;
    while(fread(&c,1,1,originalPartCutDescFile))
    {
        // Look for .pac</File>
        if (c == '<' && prev_c == 'c')
        {
            entriesCount++;
        }
        prev_c = c;
    }

    // Each position will hold a file name found between the <File>PATH_TO_FILE/fileName</File>
    partCutDescEntries = (PartCutDescEntry*) calloc(entriesCount*10,sizeof(PartCutDescEntry));

    int currentEntry = 0;
    prev_c = '\0'; // Resets

    // Goes back to the beginning of the file
    rewind(originalPartCutDescFile);

    // Now we are going to find the file names, and fill the partCutDescEntries array
    while(fread(&c,1,1,originalPartCutDescFile))
    {
        if (c == '/')
        {
            // Keeps updating the starting point so when it finds .pac</File> later, it will have where the last '/' was
            partCutDescEntries[currentEntry].lastSlash = ftell(originalPartCutDescFile);
        }
        else if (c == '>' && prev_c != '-')
        {
             partCutDescEntries[currentEntry].lastCloseTag = ftell(originalPartCutDescFile);
        }
        else if (c == '<' && prev_c == 'c') // If it found .pac</File>
        {
            // Marks the position before the < from </File>
            partCutDescEntries[currentEntry].fileNameEnd = ftell(originalPartCutDescFile) - 1;

           // Calculates the length of the file name
            long fileNameLength = (partCutDescEntries[currentEntry].fileNameEnd - partCutDescEntries[currentEntry].lastSlash);

            // Allocates the memory
            partCutDescEntries[currentEntry].fileName = (char*) malloc((fileNameLength + 1) * sizeof(char));

            // Gos back to where the name starts (after the last /)
            fseek(originalPartCutDescFile, partCutDescEntries[currentEntry].lastSlash,SEEK_SET);

            // Reads the file name from the file
            fread(partCutDescEntries[currentEntry].fileName,fileNameLength,sizeof(char),originalPartCutDescFile);

            // Ends the string
            partCutDescEntries[currentEntry].fileName[fileNameLength] = '\0';

            // Skips the < so we don't read it again
            fseek(originalPartCutDescFile, 1,SEEK_CUR);

            currentEntry++;

            if (currentEntry > entriesCount)
            {
                entriesCount = currentEntry;
                printf("\nWarning: currentEntry > entriesCount\n");
                break;
            }
        }
        prev_c = c;
    }


    // Now we are going to compare each file block with the entries we have, if they match, add a comment tag.
    int i = 0;
    int j = 0;

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        // If I need to remove this file
        if (fileBlocks[i].needPatch)
        {
            // Conditions to reduce the amount of times we have to go through all the entries for each file block
            if ((fileBlocks[i].fileName[0] == 'p' || fileBlocks[i].fileName[0] == 'P')
            && (fileHasExt(fileBlocks[i].fileName,"pac"))
            && (strstr(fileBlocks[i].folderName,"1_pc")))
            {
                for (j = 0; j < entriesCount; j++)
                {
                    if (strcmpi(fileBlocks[i].fileName,partCutDescEntries[j].fileName) == 0)
                    {
                        printColor("Remove",YELLOW);
                        printf(" - %s\n", fileBlocks[i].fileName);
                        fseek(originalPartCutDescFile,partCutDescEntries[j].lastCloseTag,SEEK_SET);

                        char* commentTagOpen = "<!--";
                        // Put it right after the <File> tag opens
                        fwrite(commentTagOpen,strlen(commentTagOpen),sizeof(char),originalPartCutDescFile);


                        char* commentTagClose = "-->";

                        // Put it right before the </File> tag closes
                        fseek(originalPartCutDescFile,partCutDescEntries[j].fileNameEnd - strlen(commentTagClose),SEEK_SET);
                        fwrite(commentTagClose,strlen(commentTagClose),sizeof(char),originalPartCutDescFile);
                    }
                }
            }
        }
        // Patches the "partcutdesc.xml" already so the game uses this modified one
        if (strcmpi(fileBlocks[i].fileName,"partcutdesc.xml") == 0)
        {
             partcutdescFileBlock = &fileBlocks[i];
        }
    }




     if (partcutdescFileBlock == NULL)
    {
        printf("\nWarning: Could not find \"partcutdesc.xml\" in your pad00000.meta file.");
        PAUSE();
    }
    else
    {
        printf("\nDone\n");
        patchMetaFile(partcutdescFileBlock,1,REMOVE_A_FILE);
    }

    fclose(originalPartCutDescFile);

    printf("\nFree...");
    /*for (j = 0; j < entriesCount; j++)
    {
        if (partCutDescEntries[j].fileName != NULL)
        {
            free(partCutDescEntries[j].fileName);
        }
    }*/
    if (partCutDescEntries != NULL)
    {
       free(partCutDescEntries);
    }
     printf("\nDone\n");
}

void writestr(char* str,FILE* fp)
{
    fwrite(str,strlen(str),1,fp);
}

char* cutTypeOpenTag(char* label)
{
    char* tag = (char*) malloc(strlen("<CutType Name=\"") + strlen(label) + strlen("\">\n") + 1);
    strcpy(tag,"<CutType Name=\"");
    strcat(tag,label);
    strcat(tag,"\">\n");
    return tag;
}

char* basicCutTypeOpenTag(char* label)
{
    char* tag = (char*) malloc(strlen("<BasicCutType Name=\"") + strlen(label) + strlen("\">\n") + 1);
    strcpy(tag,"<BasicCutType Name=\"");
    strcat(tag,label);
    strcat(tag,"\">\n");
    return tag;
}

char* getFileBlockFullPath(FileBlock fileBlock)
{
    return concatenate(substr(fileBlock.folderName,strlen("character/model/"),strlen(fileBlock.folderName)),fileBlock.fileName);
}

void addToPartCutDesc(FileBlock fileBlock, FILE* partcutdesc)
{
    char* fileOpenTag1 = "\t<File>";
    char* fileCloseTag1 = "</File>\n";
    char* fileOpenTag2 = "\t<!-- <File>";
    char* fileCloseTag2 = "</File> -->\n";
    if(strcmpi(getFileExt(fileBlock.fileName),"pac") == 0)
     {
         if (fileBlock.needPatch == 1)
         {
            writestr(fileOpenTag2,partcutdesc);
         }
         else
         {
             writestr(fileOpenTag1,partcutdesc);
         }

         writestr(getFileBlockFullPath(fileBlock),partcutdesc);

         if (fileBlock.needPatch == 1)
         {
            writestr(fileCloseTag2,partcutdesc);
            printColor("\nRemoved",YELLOW);printf(" - %s", fileBlock.fileName);
         }
         else
         {
             writestr(fileCloseTag1,partcutdesc);
         }
     }
}
void createCutTypeBlock(char* blockName,char* compareFolderName,int* classAllowed, FILE* partcutdesc, MetaFileInfo* metaFileInfo,FileBlock* fileBlocks)
{
    int i = 0;

    char* openTag = cutTypeOpenTag(blockName);
    writestr(openTag, partcutdesc);
    free(openTag);

    for (i = 0; i < metaFileInfo->fileBlocksCount; i++)
    {
        // Example if folder name is "character/model/1_pc/2_phw/armor/9_upperbody/", last folder will have "9_upperbody"
         char* lastFolder = getLastFolder(fileBlocks[i].folderName);

         // Following the last example, if the last folder name is "9_upperbody" and the second argument that we've passed to this function is also "9_upperbody", do this:
         if (strcmpi(lastFolder,compareFolderName) == 0)
         {
             char* classPrefix = getClassPrefix(fileBlocks[i].fileName);

            if (classAllowed[PHM])
            {
                if (strcmpi(classPrefix,"phm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PHW])
            {
                if (strcmpi(classPrefix,"phw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PEW])
            {
                if (strcmpi(classPrefix,"pew") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PGM])
            {
                if (strcmpi(classPrefix,"pgm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PBW])
            {
                if (strcmpi(classPrefix,"pbw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PKM])
            {
                if (strcmpi(classPrefix,"pkm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PVW])
            {
                if (strcmpi(classPrefix,"pvw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PWM])
            {
                if (strcmpi(classPrefix,"pwm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PWW])
            {
                if (strcmpi(classPrefix,"pww") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PHM])
            {
                if (strcmpi(classPrefix,"phm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PNW])
            {
                if (strcmpi(classPrefix,"pnw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PNM])
            {
                if (strcmpi(classPrefix,"pnm") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PDW])
            {
                if (strcmpi(classPrefix,"pdw") == 0)
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PKWW])
            {
                if (contains(classPrefix,"pkw"))
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            if (classAllowed[PCM])
            {
                if (contains(classPrefix,"pcm"))
                {
                    addToPartCutDesc(fileBlocks[i], partcutdesc);
                }
            }
            free(classPrefix);
         }
         free(lastFolder);
    }
    writestr("</CutType>\n\n",partcutdesc);
}
