#include "../include/texture_utils.h"

int findOriginalTextureName(char* unknownTextureName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    int i = 0;
    for (i = metaFileInfo->textureFileBlocksStart; i < metaFileInfo->textureFileBlocksEnd; i++)
    {
        printf("\n%s - %s", unknownTextureName, fileBlocks[i].fileName);
    }
    return 0;
}

FileBlock** getTexturesFrom(FileBlock* fileBlock, char* fileLocation, int* return_texture_count, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    printf("\nGetting Textures Names from %s...", fileBlock->fileName);
    char** textureNames = (char**)malloc(MAX_TEXTURES * sizeof(char*));

      int i = 0;
    for(i = 0; i < MAX_TEXTURES; i++)
    {
        textureNames[i] = (char*) malloc(MAX_PATH);
    }

    FileBlock** textures = (FileBlock**) calloc(MAX_TEXTURES , sizeof(FileBlock));
    int texturesCount = 0;

    FILE* PACFile = openFile(concatenate(fileLocation,fileBlock->fileName), "rb");

    char c = '\0';
    int legibleCharCount = 0;
    int underlineCount = 0;
    char c_anterior = '\0';
    //int lastUnderline = -1;

    while (fread(&c,1,1,PACFile))
    {
         if (texturesCount >= MAX_TEXTURES)
         {
             printf("\nWarning: The number of textures loaded exceeds the limit of %d!", MAX_TEXTURES);
             break;
         }

        if (isNumOrLetter(c) && legibleCharCount < MAX_PATH)
        {
            textureNames[texturesCount][legibleCharCount] = c;
            textureNames[texturesCount][legibleCharCount + 1] = '\0';
            legibleCharCount++;
        }
        else
        {
            if ((underlineCount >= 1)
                && (textureNames[texturesCount][0] != '_')
                && (textureNames[texturesCount][strlen(textureNames[texturesCount])-1] != '_'))
            {
                strcat(textureNames[texturesCount],".dds");
                char* textureFileNameNoExt = substr(textureNames[texturesCount],0,strlen(textureNames[texturesCount]) - 4);

                for(i = metaFileInfo->textureFileBlocksStart; i <= metaFileInfo->textureFileBlocksEnd; i++)
                {
                    if ( strlen(textureFileNameNoExt) > 3 && beginsWith(fileBlocks[i].fileName,textureFileNameNoExt) && abs(strlen(textureFileNameNoExt) - strlen(fileBlocks[i].fileName)) <= 8)
                    {
                         textures[texturesCount] = &fileBlocks[i];

                        printf("\n%d - %s",texturesCount + 1, textures[texturesCount]->fileName);

                        texturesCount++;
                        if (texturesCount >= MAX_TEXTURES)
                        {
                            printf("\nToo many textures!\n\n");
                            PAUSE();
                            (*return_texture_count) = texturesCount - 1;
                            fclose(PACFile);
                            for(i = 0; i < MAX_TEXTURES; i++)
                            {
                                free(textureNames[i]);
                            }
                            free(textureNames);
                            return textures;
                        }
                    }
                }
                  free(textureFileNameNoExt);
            }
            legibleCharCount = 0;
            //lastUnderline = ftell(PACFile);
        }
        if (legibleCharCount > 0)
        {
            if (c == '_' && c_anterior != '_')
            {
                underlineCount++;
                //lastUnderline = ftell(PACFile);
            }
        }
        else
        {
            underlineCount = 0;
        }
        c_anterior = c;
    }
    printf("\n\n");
    (*return_texture_count) = texturesCount;
    fclose(PACFile);
    for(i = 0; i < MAX_TEXTURES; i++)
    {
        free(textureNames[i]);
    }
    free(textureNames);
    return textures;
}


void extractTexturesFrom(FileBlock* fileBlockSelected, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo, char* fileBlockExtractedLocation, int openAfterExtracted)
{
    int texturesCount = 0;

    FileBlock** textures = getTexturesFrom(fileBlockSelected,fileBlockExtractedLocation,&texturesCount,fileBlocks,metaFileInfo);

    if (texturesCount == 0 || textures == NULL)
    {
        printf("\nFailed to get textures from \"%s\"\n\n", fileBlockSelected->fileName);
        printf("Textures count = %d\n", texturesCount);
        system("PAUSE");
    }
    else
    {
        int i = 0;
        for(i = 0; i < texturesCount; i++)
        {
            if (textures[i]->fileName != NULL)
            {
                char* textureFullPath = concatenate(fileBlockExtractedLocation,textures[i]->fileName);
                if (!fileExists(textureFullPath))
                {
                    extractFileCustomPath(textures[i],fileBlockExtractedLocation,1);
                }
                free(textureFullPath);
            }
        }


        if (openAfterExtracted)
        {
            openFolder(fileBlockExtractedLocation);
        }
    }
    free(textures);
}



void getFilesFromTexture(char* textureName, FileBlock* fileBlocks, MetaFileInfo* metaFileInfo)
{
    if (textureName[strlen(textureName)-1] == '\n')
    {
        textureName[strlen(textureName)-1] = '\0';
    }
    printf("\nGetting files that strstr: \"%s\"\n", textureName);
    char* extractionLocation = concatenate("patcher_resources\\extracted_files\\",textureName);
    charReplace(extractionLocation,'.','_');
    charReplace(extractionLocation,'\n','\\');

    if (extractionLocation[strlen(extractionLocation)-1] != '\\')
    {
        extractionLocation = concatenate(extractionLocation,"\\");
    }
    int i = 0;
    int j = 0;
    int filesCount = 0;
    int processedCount = 0;

    for (i = metaFileInfo->pacFileBlocksStart; i <= metaFileInfo->pacFileBlocksEnd; i++)
    {
        if (isAccordingToFilters(&fileBlocks[i]))
        {
            filesCount++;
        }
    }



    int run = 0;
    for(run = 0; run < 2; run++)
    {
        for (i = metaFileInfo->pacFileBlocksStart; i <= metaFileInfo->pacFileBlocksEnd; i++)
        {
             if (((run == 0) && (strcmpi(getClassPrefix(textureName),getClassPrefix(fileBlocks[i].fileName)) == 0) && !strstr(fileBlocks[i].folderName,"nude")) // First run, same class
              || ((run == 1) && (strcmpi(getClassPrefix(textureName),getClassPrefix(fileBlocks[i].fileName)) != 0))
              || ((run == 1) && (strstr(fileBlocks[i].folderName,"nude")))) // Second run, different class
             {
                if (isAccordingToFilters(&fileBlocks[i]))
                {
                    printf("(%d/%d)- %.2f percent done", processedCount + 1, filesCount,(float)((double)processedCount/(double)filesCount) * 100.0);
                    extractFileCustomPath(&fileBlocks[i],extractionLocation,0);
                    int textureCount = 0;
                    FileBlock** textures = getTexturesFrom(&fileBlocks[i],extractionLocation,&textureCount,fileBlocks,metaFileInfo);

                    int found = 0;
                    for (j = 0; j < textureCount; j++)
                    {
                        if (strcmpi(textures[j]->fileName,textureName) == 0)
                        {
                            printf("\n%s has your texture!", fileBlocks[i].fileName);
                            found = 1;
                            break;
                        }
                    }
                    if (found)
                    {
                         char* extractionLocation_PAC_FILE = concatenate(extractionLocation,fileBlocks[i].fileName);

                         // Replaces the folder name from filename.pac to filename/
                         for(j = 0; j < strlen(extractionLocation_PAC_FILE); j++)
                         {
                            if (extractionLocation_PAC_FILE[j] == '.')
                            {
                                extractionLocation_PAC_FILE[j] = '\\';
                                if (j + 1 < strlen(extractionLocation_PAC_FILE))
                                {
                                    extractionLocation_PAC_FILE[j+1] = '\0';
                                }
                            }
                         }

                         createPath(extractionLocation_PAC_FILE);
                         moveFile(fileBlocks[i].fileName,extractionLocation,extractionLocation_PAC_FILE);

                         for (j = 0; j < textureCount; j++)
                         {
                             if (textures[i]->fileName != NULL)
                             {
                                 extractFileCustomPath(textures[i],extractionLocation_PAC_FILE,0);
                             }
                         }
                        char* command = (char*) malloc(strlen("start %s") + strlen(extractionLocation_PAC_FILE) + 1);
                        sprintf(command,"start %s", extractionLocation_PAC_FILE);
                        system(command);
                        free(command);
                        free(extractionLocation_PAC_FILE);

                        PAUSE();
                    }
                    remove(concatenate(extractionLocation,fileBlocks[i].fileName));

                      free(textures);
                    processedCount++;
                    if (processedCount == filesCount)
                    {
                        break;
                    }
                }

            }

        }

    }
       char* command = (char*) malloc(strlen("start %s") + strlen(extractionLocation) + 1);
        sprintf(command,"start %s", extractionLocation);
        system(command);
        free(command);
}

int isAccordingToFilters(FileBlock* fileBlock)
{
    if (strstr(fileBlock->folderName,"1_pc")
            && !strstr(fileBlock->folderName,"weapon")
            && !strstr(fileBlock->folderName,"head")
            && !strstr(fileBlock->folderName,"etc")
            && !strstr(fileBlock->folderName,"40_glasses")
            && !strstr(fileBlock->folderName,"41_piercing")
            && !strstr(fileBlock->fileName,"earring")
            && !strstr(fileBlock->fileName,"dummy")
            )
        {
            return 1;
        }
        return 0;
}
